module FMap
  (
    AList(..), update, assoc, assocM, remove, 
               dom, ran, restrict, mapran
  )
where

import Error

-- finite maps
type AList a b = [(a,b)]

update x y xys = (x,y):xys
assocM xys x = case [y | (x',y)<-xys, x==x'] of
                 (y:_) -> Success y
                 [] -> Error (show x++" not found in "++
                              show xys++"\n")
assoc xys x = case [y | (x',y)<-xys, x==x'] of
                (y:_) -> y
		[] -> error (show x++" not found in "++
		             show xys++"\n")
remove x xys = restrict (/=x) xys
dom xys = map fst xys
ran xys = map snd xys
restrict p xys = [(x,y)|(x,y)<-xys, p x]
mapran f xys = [(x,f y)|(x,y)<-xys]

