module BasicData where

type DataName = String
type ConstructorName = String 
                                           
data Constructor a = Constructor ConstructorName [a]
                   deriving (Eq, Read, Show) 

constrName (Constructor c _) = c
constrArgs (Constructor _ args) = args

constrArgsOf _ [] = Nothing
constrArgsOf cname (Constructor c args:cs) =
  if cname == c
   then Just args
   else constrArgsOf cname cs
